## distrobuilder 3.0

=== Makefile ===
VERSION=$(shell grep "var Version" shared/version/version.go | cut -d'"' -f2)
ARCHIVE=distrobuilder-$(VERSION).tar
GO111MODULE=on
SPHINXENV=.sphinx/venv/bin/activate

.PHONY: default
default:
	gofmt -s -w .
	go install -v ./...
	@echo "distrobuilder built successfully"

.PHONY: update-gomod
update-gomod:
	go get -t -v -d -u ./...
	go mod tidy

.PHONY: check
check: default
	go test -v ./...

.PHONY: dist
dist:
	# Cleanup
	rm -Rf $(ARCHIVE).gz

	# Create build dir
	$(eval TMP := $(shell mktemp -d))
	git archive --prefix=distrobuilder-$(VERSION)/ HEAD | tar -x -C $(TMP)
	mkdir -p $(TMP)/_dist/src/github.com/lxc
	ln -s ../../../../distrobuilder-$(VERSION) $(TMP)/_dist/src/github.com/lxc/distrobuilder

	# Download dependencies
	cd $(TMP)/distrobuilder-$(VERSION) && go mod vendor

	# Assemble tarball
	tar --exclude-vcs -C $(TMP) -zcf $(ARCHIVE).gz distrobuilder-$(VERSION)/

	# Cleanup
	rm -Rf $(TMP)

.PHONY: doc-setup
doc-setup:
	@echo "Setting up documentation build environment"
	python3 -m venv .sphinx/venv
	. $(SPHINXENV) ; pip install --upgrade -r .sphinx/requirements.txt
	mkdir -p .sphinx/deps/ .sphinx/themes/
	wget -N -P .sphinx/_static/download https://linuxcontainers.org/static/img/favicon.ico https://linuxcontainers.org/static/img/containers.png https://linuxcontainers.org/static/img/containers.small.png
	rm -Rf doc/html

.PHONY: doc
doc: doc-setup doc-incremental

.PHONY: doc-incremental
doc-incremental:
	@echo "Build the documentation"
	. $(SPHINXENV) ; sphinx-build -c .sphinx/ -b dirhtml doc/ doc/html/ -w .sphinx/warnings.txt

.PHONY: doc-serve
doc-serve:
	cd doc/html; python3 -m http.server 8001

.PHONY: doc-spellcheck
doc-spellcheck: doc
	. $(SPHINXENV) ; python3 -m pyspelling -c .sphinx/.spellcheck.yaml

.PHONY: doc-linkcheck
doc-linkcheck: doc-setup
	. $(SPHINXENV) ; sphinx-build -c .sphinx/ -b linkcheck doc/ doc/html/

.PHONY: doc-lint
doc-lint:
	.sphinx/.markdownlint/doc-lint.sh

.PHONY: static-analysis
static-analysis:
ifeq ($(shell command -v golangci-lint 2> /dev/null),)
	go install github.com/golangci/golangci-lint/cmd/golangci-lint@v1.52.2
endif
	golangci-lint run --timeout 5m
	run-parts --exit-on-error --regex '.sh' test/lint

=== .sphinx/requirements.txt ===
alabaster
Babel
certifi
charset-normalizer
colorama
docutils
idna
imagesize
Jinja2
livereload
MarkupSafe
packaging
Pygments
pyparsing
pytz
requests
six
snowballstemmer
Sphinx
sphinx-autobuild
sphinxcontrib-applehelp
sphinxcontrib-devhelp
sphinxcontrib-htmlhelp
sphinxcontrib-jsmath
sphinxcontrib-qthelp
sphinxcontrib-serializinghtml
sphinxcontrib-jquery
tornado
urllib3
myst-parser
sphinx-tabs
sphinx-reredirects
linkify-it-py
furo
sphinxext-opengraph>=0.6.1
lxd-sphinx-extensions
pyspelling
sphinx-design

=== debian/changelog ===
distrobuilder (3.0-1) unstable; urgency=medium

  * Initial release (Closes: #1061706)

 -- Mathias Gibbens <gibmat@debian.org>  Sun, 18 Feb 2024 18:06:31 +0000

=== debian/control ===
Source: distrobuilder
Maintainer: Debian Go Packaging Team <team+pkg-go@tracker.debian.org>
Uploaders: Mathias Gibbens <gibmat@debian.org>
Section: golang
Testsuite: autopkgtest-pkg-go
Priority: optional
Build-Depends: debhelper-compat (= 13),
               dh-golang,
               help2man,
               squashfs-tools,
               golang-any,
               golang-github-antchfx-htmlquery-dev,
               golang-github-flosch-pongo2.v4-dev,
               golang-github-google-go-github-dev,
               golang-github-lxc-incus-dev,
               golang-github-mudler-docker-companion-dev,
               golang-github-sirupsen-logrus-dev,
               golang-github-spf13-cobra-dev,
               golang-github-stretchr-testify-dev,
               golang-golang-x-sys-dev,
               golang-golang-x-text-dev,
               golang-gopkg-yaml.v2-dev
Standards-Version: 4.6.2
Vcs-Browser: https://salsa.debian.org/go-team/packages/distrobuilder
Vcs-Git: https://salsa.debian.org/go-team/packages/distrobuilder.git
Homepage: https://github.com/lxc/distrobuilder
Rules-Requires-Root: no
XS-Go-Import-Path: github.com/lxc/distrobuilder

Package: distrobuilder
Architecture: any
Depends: debootstrap,
         distrobuilder-images,
         gpg,
         rsync,
         squashfs-tools,
         xz-utils,
         ${misc:Depends},
         ${shlibs:Depends}
Recommends: dosfstools,
            btrfs-progs,
            gdisk,
            qemu-utils
Built-Using: ${misc:Built-Using}
Description: System container image builder for LXC and Incus
 distrobuilder is an image building tool for LXC and Incus.
 .
 Its modern design uses pre-built official images whenever available and
 supports a variety of modifications on the base image. distrobuilder creates
 LXC or Incus images, or just a plain root file system, from a declarative
 image definition (in YAML format) that defines the source of the image, its
 package manager, what packages to install or remove for specific image
 variants, OS releases and architectures, as well as additional files to
 generate and arbitrary actions to execute as part of the image build process.
 .
 Incus images may also be compatible with Canonical's LXD.

=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%@PACKAGE@-$1.tar.gz%,\
      uversionmangle=s/(\d)[_\.\-\+]?(RC|rc|pre|dev|beta|alpha)[.]?(\d*)$/$1~$2$3/" \
  https://github.com/lxc/distrobuilder/tags .*/v?(\d\S*)\.tar\.gz debian

## distrobuilder 3.1

=== Makefile ===
--- 
+++ 
@@ -2,9 +2,12 @@
 ARCHIVE=distrobuilder-$(VERSION).tar
 GO111MODULE=on
 SPHINXENV=.sphinx/venv/bin/activate
+GOPATH=$(shell go env GOPATH)
 
 .PHONY: default
 default:
+	go env -w GOCACHE=$(shell go env GOCACHE)
+	$(shell go env | grep -v GOENV | sed "s/'//g" > $(shell go env GOENV))
 	gofmt -s -w .
 	go install -v ./...
 	@echo "distrobuilder built successfully"
@@ -12,11 +15,11 @@
 .PHONY: update-gomod
 update-gomod:
 	go get -t -v -d -u ./...
-	go mod tidy
+	go mod tidy -go=1.22.7
 
 .PHONY: check
 check: default
-	go test -v ./...
+	sudo GOENV=$(shell go env GOENV) go test -v ./...
 
 .PHONY: dist
 dist:
@@ -73,8 +76,8 @@
 
 .PHONY: static-analysis
 static-analysis:
-ifeq ($(shell command -v golangci-lint 2> /dev/null),)
-	go install github.com/golangci/golangci-lint/cmd/golangci-lint@v1.52.2
+ifeq ($(shell command -v golangci-lint),)
+	curl -sSfL https://raw.githubusercontent.com/golangci/golangci-lint/master/install.sh | sh -s -- -b $(GOPATH)/bin
 endif
-	golangci-lint run --timeout 5m
-	run-parts --exit-on-error --regex '.sh' test/lint
+	$(GOPATH)/bin/golangci-lint run --timeout 5m
+	run-parts $(shell run-parts -V 2> /dev/null 1> /dev/null && echo -n "--exit-on-error --regex '.sh'") test/lint

=== .sphinx/requirements.txt ===
--- 
+++ 
@@ -27,7 +27,7 @@
 sphinxcontrib-jquery
 tornado
 urllib3
-myst-parser
+myst-parser<3.0.0
 sphinx-tabs
 sphinx-reredirects
 linkify-it-py

=== debian/changelog ===
distrobuilder (3.1-1) unstable; urgency=medium

  * New upstream release:
    - Rebase patches as needed
    - Drop patches applied upstream
  * Add gnupg to Build-Depends in d/control

 -- Mathias Gibbens <gibmat@debian.org>  Sat, 26 Oct 2024 00:51:05 +0000

distrobuilder (3.0-4) unstable; urgency=medium

  * Update Standards-Version to 4.7.0 in d/control (no changes needed)
  * Cherry-pick upstream fix to handle parsing pre-release versions of systemd
  * Cherry-pick upstream fix for newer versions of systemd within a container

 -- Mathias Gibbens <gibmat@debian.org>  Sat, 01 Jun 2024 13:43:42 +0000

distrobuilder (3.0-3) unstable; urgency=medium

  * Add a patch to fix building with incus >= 0.7

 -- Mathias Gibbens <gibmat@debian.org>  Tue, 26 Mar 2024 22:55:20 +0000

distrobuilder (3.0-2) unstable; urgency=medium

  * Fix d/watch
  * Switch d/gitlab-ci.yml to full build pipeline
    - Add a patch to skip part of test that fails in salsa CI environment
  * Adjust patching of import path for google-go-github to not tie to a
    specific version

 -- Mathias Gibbens <gibmat@debian.org>  Sun, 17 Mar 2024 01:12:27 +0000

=== debian/control ===
--- 
+++ 
@@ -6,13 +6,14 @@
 Priority: optional
 Build-Depends: debhelper-compat (= 13),
                dh-golang,
+               gnupg,
                help2man,
                squashfs-tools,
                golang-any,
                golang-github-antchfx-htmlquery-dev,
                golang-github-flosch-pongo2.v4-dev,
                golang-github-google-go-github-dev,
-               golang-github-lxc-incus-dev,
+               golang-github-lxc-incus-dev (>= 0.7),
                golang-github-mudler-docker-companion-dev,
                golang-github-sirupsen-logrus-dev,
                golang-github-spf13-cobra-dev,
@@ -20,7 +21,7 @@
                golang-golang-x-sys-dev,
                golang-golang-x-text-dev,
                golang-gopkg-yaml.v2-dev
-Standards-Version: 4.6.2
+Standards-Version: 4.7.0
 Vcs-Browser: https://salsa.debian.org/go-team/packages/distrobuilder
 Vcs-Git: https://salsa.debian.org/go-team/packages/distrobuilder.git
 Homepage: https://github.com/lxc/distrobuilder

## distrobuilder 3.2

=== Makefile ===
--- 
+++ 
@@ -6,16 +6,16 @@
 
 .PHONY: default
 default:
-	go env -w GOCACHE=$(shell go env GOCACHE)
-	$(shell go env | grep -v GOENV | sed "s/'//g" > $(shell go env GOENV))
 	gofmt -s -w .
 	go install -v ./...
 	@echo "distrobuilder built successfully"
 
 .PHONY: update-gomod
 update-gomod:
-	go get -t -v -d -u ./...
-	go mod tidy -go=1.22.7
+	go get -t -v -u ./...
+	go mod tidy -go=1.23.7
+	go get toolchain@none
+	@echo "Dependencies updated"
 
 .PHONY: check
 check: default
@@ -79,5 +79,9 @@
 ifeq ($(shell command -v golangci-lint),)
 	curl -sSfL https://raw.githubusercontent.com/golangci/golangci-lint/master/install.sh | sh -s -- -b $(GOPATH)/bin
 endif
+ifeq ($(shell command -v codespell),)
+	echo "Please install codespell"
+	exit 1
+endif
 	$(GOPATH)/bin/golangci-lint run --timeout 5m
 	run-parts $(shell run-parts -V 2> /dev/null 1> /dev/null && echo -n "--exit-on-error --regex '.sh'") test/lint

=== debian/changelog ===
distrobuilder (3.2-4) unstable; urgency=medium

  * Cherry-pick patch for Incus API changes

 -- Mathias Gibbens <gibmat@debian.org>  Thu, 21 Aug 2025 14:10:10 +0000

distrobuilder (3.2-3) unstable; urgency=medium

  * Update Build-Depends
    - Rebase d/p/001-fixup-imports.patch

 -- Mathias Gibbens <gibmat@debian.org>  Sun, 10 Aug 2025 16:10:34 +0000

distrobuilder (3.2-2) unstable; urgency=medium

  * d/control:
    - Add back Built-Using stanza
    - Add additional dependencies for repacking Windows install images
      to list of Recommended packages

 -- Mathias Gibbens <gibmat@debian.org>  Sun, 27 Apr 2025 16:58:53 +0000

distrobuilder (3.2-1) unstable; urgency=medium

  * New upstream release
    - Rebase patches as needed
  * d/control:
    - Update Standards-Version to 4.7.2 (no changes needed)
    - Replace Built-Using with Static-Built-Using
  * Update years in d/copyright

 -- Mathias Gibbens <gibmat@debian.org>  Fri, 04 Apr 2025 11:38:57 +0000

=== debian/control ===
--- 
+++ 
@@ -11,9 +11,9 @@
                squashfs-tools,
                golang-any,
                golang-github-antchfx-htmlquery-dev,
-               golang-github-flosch-pongo2.v4-dev,
+               golang-github-flosch-pongo2.v6-dev,
                golang-github-google-go-github-dev,
-               golang-github-lxc-incus-dev (>= 0.7),
+               golang-github-lxc-incus-dev (>= 6.0.5),
                golang-github-mudler-docker-companion-dev,
                golang-github-sirupsen-logrus-dev,
                golang-github-spf13-cobra-dev,
@@ -21,7 +21,7 @@
                golang-golang-x-sys-dev,
                golang-golang-x-text-dev,
                golang-gopkg-yaml.v2-dev
-Standards-Version: 4.7.0
+Standards-Version: 4.7.2
 Vcs-Browser: https://salsa.debian.org/go-team/packages/distrobuilder
 Vcs-Git: https://salsa.debian.org/go-team/packages/distrobuilder.git
 Homepage: https://github.com/lxc/distrobuilder
@@ -41,8 +41,12 @@
 Recommends: dosfstools,
             btrfs-progs,
             gdisk,
-            qemu-utils
+            genisoimage,
+            libwin-hivex-perl,
+            qemu-utils,
+            wimtools
 Built-Using: ${misc:Built-Using}
+Static-Built-Using: ${misc:Static-Built-Using}
 Description: System container image builder for LXC and Incus
  distrobuilder is an image building tool for LXC and Incus.
  .

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/pkg-info.mk

export DH_GOLANG_INSTALL_EXTRA := distrobuilder/lxc.generator

%:
	dh $@ --builddirectory=_build --buildsystem=golang --with=golang

execute_after_dh_auto_build:
	# Autogenerate a man page
	mkdir man1/
	TZ=UTC HOME="~" help2man _build/bin/distrobuilder -n "System container image builder" --no-info --no-discard-stderr --version-string=$(DEB_VERSION_UPSTREAM) > man1/distrobuilder.1

override_dh_auto_install:
	dh_auto_install -- --no-source

=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%@PACKAGE@-$1.tar.gz%,\
      uversionmangle=s/(\d)[_\.\-\+]?(RC|rc|pre|dev|beta|alpha)[.]?(\d*)$/$1~$2$3/" \
  https://github.com/lxc/distrobuilder/tags .*/distrobuilder-(\d\S*)\.tar\.gz debian

## distrobuilder 3.3.0

=== Makefile ===
--- 
+++ 
@@ -3,6 +3,7 @@
 GO111MODULE=on
 SPHINXENV=.sphinx/venv/bin/activate
 GOPATH=$(shell go env GOPATH)
+export GOFLAGS=-tags=containers_image_storage_stub,containers_image_docker_daemon_stub,containers_image_openpgp
 
 .PHONY: default
 default:
@@ -13,13 +14,13 @@
 .PHONY: update-gomod
 update-gomod:
 	go get -t -v -u ./...
-	go mod tidy -go=1.23.7
+	go mod tidy --go=1.25.6
 	go get toolchain@none
 	@echo "Dependencies updated"
 
 .PHONY: check
 check: default
-	sudo GOENV=$(shell go env GOENV) go test -v ./...
+	sudo GOENV=$(shell go env GOENV) GOFLAGS=$(GOFLAGS) go test -v ./...
 
 .PHONY: dist
 dist:

=== debian/changelog ===
distrobuilder (3.3.0-1) unstable; urgency=medium

  * New upstream release:
    - Drop patch applied upstream
    - Rebase d/p/002-skip-internet-tests.patch
  * d/control:
    - Update Standards-Version to 4.7.3, drop Priority field
    - Update Build-Depends
    - Drop redundant Rules-Requires-Root
  * Update years in d/copyright

 -- Mathias Gibbens <gibmat@debian.org>  Mon, 23 Feb 2026 23:26:17 +0000

## distrobuilder 3.3.1

=== debian/changelog ===
distrobuilder (3.3.1-1) unstable; urgency=medium

  * New upstream release
    - Rebase d/p/001-fixup-imports.patch
  * Update d/watch for new tagging convention

 -- Mathias Gibbens <gibmat@debian.org>  Wed, 25 Feb 2026 18:26:08 +0000

=== debian/control ===
--- 
+++ 
@@ -3,7 +3,6 @@
 Uploaders: Mathias Gibbens <gibmat@debian.org>
 Section: golang
 Testsuite: autopkgtest-pkg-go
-Priority: optional
 Build-Depends: debhelper-compat (= 13),
                dh-golang,
                gnupg,
@@ -11,21 +10,22 @@
                squashfs-tools,
                golang-any,
                golang-github-antchfx-htmlquery-dev,
+               golang-github-containers-image-dev,
                golang-github-flosch-pongo2.v6-dev,
                golang-github-google-go-github-dev,
                golang-github-lxc-incus-dev (>= 6.0.5),
-               golang-github-mudler-docker-companion-dev,
+               golang-github-opencontainers-image-spec-dev,
+               golang-github-opensuse-umoci-dev,
                golang-github-sirupsen-logrus-dev,
                golang-github-spf13-cobra-dev,
                golang-github-stretchr-testify-dev,
                golang-golang-x-sys-dev,
                golang-golang-x-text-dev,
                golang-gopkg-yaml.v2-dev
-Standards-Version: 4.7.2
+Standards-Version: 4.7.3
 Vcs-Browser: https://salsa.debian.org/go-team/packages/distrobuilder
 Vcs-Git: https://salsa.debian.org/go-team/packages/distrobuilder.git
 Homepage: https://github.com/lxc/distrobuilder
-Rules-Requires-Root: no
 XS-Go-Import-Path: github.com/lxc/distrobuilder
 
 Package: distrobuilder

=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%@PACKAGE@-$1.tar.gz%,\
      uversionmangle=s/(\d)[_\.\-\+]?(RC|rc|pre|dev|beta|alpha)[.]?(\d*)$/$1~$2$3/" \
  https://github.com/lxc/distrobuilder/tags .*/v(\d\S*)\.tar\.gz debian
